discussion/urls.py
from django.contrib import admin
from django.urls import path, include


urlpatterns = [
    path('todolist/', include('todolist.urls')),
    path('admin/', admin.site.urls),
]

todolist/urls.py
from django.urls import path
from . import views
'''
	path()
		Syntax:
			path(route, view, name)

'''
app_name = 'todolist'
urlpatterns = [
  # /todoitem route
  path('', views.index, name='index'),
  
  # /todoitem/<todoitem_id> route
  path('<int:todoitem_id>/', views.todoitem, name='viewtodoitem'),

  # /register
  path('register/', views.register, name='register'),

  # /change_password
  path('change_password/', views.change_password, name='change_password'),

  # /login_view
  path('login/', views.login_view, name="login"),

  # /logout_view
  path('logout/', views.logout_view, name="logout"),

  # /add_task
  path('add_task/', views.add_task, name="add_task"),

  # /edit
  path('<int:todoitem_id>/edit', views.update_task, name="update_task"),

  # /delete
  path('<int:todoitem_id>/delete', views.delete_task, name='delete_task'),

  path('add_event/', views.add_event, name="add_event"),

  path('event/<int:eventitem_id>/', views.eventitem, name='vieweventitem'),

   path('event/<int:eventitem_id>/edit', views.update_event, name="update_event"),

     path('event/<int:eventitem_id>/delete', views.delete_event, name='delete_event'),

]

todolist/models.py
from django.db import models
from django.contrib.auth.models import User

# Create your models here.
# models.Model - subclass
class ToDoItem(models.Model):
  task_name = models.CharField(max_length=50)
  description = models.CharField(max_length=200)
  status = models.CharField(max_length=50, default="pending")
  date_created = models.DateTimeField('date created')
  user = models.ForeignKey(User, on_delete=models.CASCADE, default="")

class EventsItem(models.Model):
  event_name = models.CharField(max_length=50)
  description = models.CharField(max_length=200)
  status = models.CharField(max_length=50, default="pending")
  event_date = models.DateTimeField('date created')
  user = models.ForeignKey(User, on_delete=models.CASCADE, default="")

todolist/forms.py
from django import forms
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.forms import PasswordChangeForm
from django.contrib.auth.models import User

class LoginForm(forms.Form):
  username = forms.CharField(label='Username', max_length=20)
  password = forms.CharField(label='Password', max_length=20)

class RegisterForm(UserCreationForm):
    first_name = forms.CharField(label='Firstname', max_length=50)
    last_name = forms.CharField(label='Lastname', max_length=50)
    email = forms.EmailField(label='Email', max_length=50)

    class Meta:
        model = User
        fields = ["username", "password1", "password2", "first_name", "last_name", "email"]

class AddTaskForm(forms.Form):
  task_name = forms.CharField(label="Task Name", max_length=50)
  description = forms.CharField(label="Description", max_length=200)

class UpdateTaskForm(forms.Form):
  task_name = forms.CharField(label='Task Name', max_length=50)
  description = forms.CharField(label="Description", max_length=200)
  status = forms.CharField(label='Status', max_length=50)

class AddEventForm(forms.Form):
  event_name = forms.CharField(label="Event Name", max_length=50)
  description = forms.CharField(label="Description", max_length=200)

class UpdateEventForm(forms.Form):
  event_name = forms.CharField(label='Event Name', max_length=50)
  description = forms.CharField(label="Description", max_length=200)
  status = forms.CharField(label='Status', max_length=50)
  event_date = forms.DateTimeField(label='Event Date', input_formats=['%Y-%m-%dT%H:%M'], widget=forms.DateTimeInput(attrs={'type': 'datetime-local'}))

class ChangePasswordForm(PasswordChangeForm):
    class Meta:
        model = User
        fields = ['old_password', 'new_password1', 'new_password2']

todolist/views.py
from django.shortcuts import render, redirect, get_object_or_404
from django.http import HttpResponse
from django.template import loader
# import User from Django
from django.contrib.auth.models import User
# import authenticate form from Django for authentication
from django.contrib.auth import authenticate, login, logout
from django.forms.models import model_to_dict
from django.utils import timezone
from django.contrib import messages
from datetime import datetime
from django.contrib.auth.decorators import login_required
from django.contrib.auth.decorators import login_required
from django.contrib.auth.forms import PasswordChangeForm
from django.contrib.auth import update_session_auth_hash

# Local imports
from .models import ToDoItem, EventsItem
from .forms import LoginForm, AddTaskForm, UpdateTaskForm, RegisterForm, AddEventForm, UpdateEventForm, ChangePasswordForm

# Create your views here.
def index(request):
  todoitem_list = ToDoItem.objects.filter(user_id=request.user.id)
  eventitem_list = EventsItem.objects.filter(user_id=request.user.id)
  context = {
    "todoitem_list": todoitem_list,
    "eventitem_list": eventitem_list,
    "user": request.user
    }
  print(eventitem_list)
  return render(request, "todolist/index.html", context)

def todoitem(request, todoitem_id):
  # retreives the item objects using the id or primary key
  todoitem = get_object_or_404(ToDoItem, pk=todoitem_id)
  # response = "You are viewing the details of %s"
  return render(request, "todolist/todoitem.html", model_to_dict(todoitem))

def eventitem(request, eventitem_id):
  # retreives the item objects using the id or primary key
  eventitem = get_object_or_404(EventsItem, pk=eventitem_id)
  # response = "You are viewing the details of %s"
  return render(request, "todolist/eventitem.html", model_to_dict(eventitem))

def register(request):
    context = {}

    if request.method == 'POST':
        form = RegisterForm(request.POST)

        if form.is_valid():
            form.save()
            context['registration_success'] = True
        else:
            context['error'] = True

    else:
        form = RegisterForm()

    context['form'] = form
    return render(request, "todolist/register.html", context)


@login_required
def change_password(request):
    is_password_changed = False

    if request.method == 'POST':
        form = PasswordChangeForm(request.user, request.POST)

        if form.is_valid():
            form.save()
            update_session_auth_hash(request, form.user)
            is_password_changed = True
    else:
        form = PasswordChangeForm(request.user)

    context = {
        'form': form,
        'is_password_changed': is_password_changed,
        'user': request.user,
    }

    return render(request, "todolist/change_password.html", context)

def login_view(request):
    # username = "johndoe"
    # password = "johndoe1"

    # user = authenticate(username=username, password=password)

    context = {}

    if request.method == 'POST':
        form = LoginForm(data=request.POST)
        
        if form.is_valid() == False:
            # Returns a blank login form
            form = LoginForm()
        else:
            # Retrieves the information from the form
            username = form.cleaned_data['username']
            password = form.cleaned_data['password']
            user = authenticate(username=username, password=password)
            context = {
                "username": username,
                "password": password
            }

        if user is not None:
            # Saves the user's ID in the session using Django's Session framework
            login(request, user)
            return redirect("todolist:index")
        else:
            # Provides context with error to conditionally render the error message
            context = {
                "error": True
            }

    return render(request, "todolist/login.html", context)


def logout_view(request):
    # Removes the saved data in session upon login
    logout(request)
    return redirect("todolist:index")

def add_task(request):
    context = {}

    if request.method == 'POST':
        form = AddTaskForm(request.POST)

        if form.is_valid() == False:
            form = AddTaskForm()
        else:
            task_name = form.cleaned_data['task_name']
            description = form.cleaned_data['description']

            # Checks the database if a task already exists
            duplicates = ToDoItem.objects.filter(task_name=task_name)

            if not duplicates:
                ToDoItem.objects.create(task_name=task_name, description=description, date_created=timezone.now(), user_id=request.user.id)
            else:
                context = {"error": True}

    return render(request, "todolist/add_task.html", context)


def update_task(request, todoitem_id):
    todoitem = ToDoItem.objects.filter(pk=todoitem_id)
    context = {
        "user": request.user,
        "todoitem_id": todoitem_id,
        "task_name": todoitem[0].task_name,
        "description": todoitem[0].description,
        "status": todoitem[0].status
    }

    if request.method == 'POST':
        form = UpdateTaskForm(request.POST)

        if form.is_valid() == False:
            form = UpdateTaskForm()
        else:
            task_name = form.cleaned_data['task_name']
            description = form.cleaned_data['description']
            status = form.cleaned_data['status']

            if todoitem:
                todoitem[0].task_name = task_name
                todoitem[0].description = description
                todoitem[0].status = status

                todoitem[0].save()
                return redirect("todolist:index")
            else:
                context = {
                    "error": True
                }

    return render(request, "todolist/update_task.html", context)

def delete_task(request, todoitem_id):
    todoitem = ToDoItem.objects.filter(pk=todoitem_id).delete()
    return redirect("todolist:index")


def add_event(request):
    context = {}

    if request.method == 'POST':
        form = AddEventForm(request.POST)

        if form.is_valid() == False:
            form = AddEventForm()
        else:
            event_name = form.cleaned_data['event_name']
            description = form.cleaned_data['description']

            event_date_str = request.POST.get('event_date')  # Adjust this line based on your actual form field name
            event_date = datetime.strptime(event_date_str, '%Y-%m-%dT%H:%M')  # Adjust the date format
            # Checks the database if a task already exists
            duplicates = EventsItem.objects.filter(event_name=event_name)

            if not duplicates:
                EventsItem.objects.create(
                    event_name=event_name, 
                    description=description, 
                    event_date=event_date, 
                    user_id=request.user.id)
            else:
                context = {"error": True}

    return render(request, "todolist/add_event.html", context)

def update_event(request, eventitem_id):
    eventitem = EventsItem.objects.filter(pk=eventitem_id)
    context = {
        "user": request.user,
        "eventitem_id": eventitem_id,
        "event_name": eventitem[0].event_name,
        "description": eventitem[0].description,
        "status": eventitem[0].status,
        "event_date": eventitem[0].event_date.strftime('%Y-%m-%dT%H:%M') if eventitem[0].event_date else ""
    }

    if request.method == 'POST':
        form = UpdateEventForm(request.POST)

        if form.is_valid():
            event_name = form.cleaned_data['event_name']
            description = form.cleaned_data['description']
            status = form.cleaned_data['status']
            event_date = form.cleaned_data['event_date']

            if eventitem:
                eventitem[0].event_name = event_name
                eventitem[0].description = description
                eventitem[0].status = status
                if event_date:  # Check if event_date is provided before updating
                    # Ensure event_date is a string before applying strptime
                    if isinstance(event_date, datetime):
                        event_date = event_date.strftime('%Y-%m-%dT%H:%M')

                    eventitem[0].event_date = datetime.strptime(event_date, '%Y-%m-%dT%H:%M')

                eventitem[0].save()

                context['update_success'] = True
            else:
                context = {
                    "error": True
                }
        else:
            context['form'] = form

    return render(request, "todolist/update_event.html", context)

def delete_event(request, eventitem_id):
    eventitem = EventsItem.objects.filter(pk=eventitem_id).delete()
    return redirect("todolist:index")

todolist/templates/todolist/add_event.html
{% extends 'base.html' %}

{% block title %}Add Event{% endblock %}

{% block content %}
  {% if user.is_anonymous == True %}
  <h1 class="text-center">You are not allowed to access this page</h1>
  {% else %}
  <div class="container">
    <div class="row">
      <div class="col-6 offset-3">
        <h1 class="text-center my-3">Add A Event</h1>
        {% if error == True %}
          <p class="text-danger">Duplicate event found</p>
        {% endif %}
        <form action="{% url 'todolist:add_event' %}" method="post">
          {% csrf_token %}

          <div class="mb-3">
              <label for="event_name">Event Name: </label>
              <input class="form-control" id="event_name" type="text" name="event_name" value="{{ event_name }}" maxlength="50" required>
          </div>

          <div class="mb-3">
              <label for="description">Description: </label>
              <textarea class="form-control" name="description" value="{{ description }}" required></textarea>
          </div>

          <div class="mb-3">
            <label for="event_date">Event Date:</label>
            <input class="form-control" id="event_date" type="datetime-local" name="event_date" required>
            <!-- You may adjust the format and style of the input field as needed -->
          </div>

          <div class="text-center">
            <input class="btn btn-success" type="submit" value="Add Task">
        </div>

        </form>
      </div>
    </div>
  </div>
  {% endif %}
{% endblock %}

todolist/templates/todolist/add_task.html
{% extends 'base.html' %}

{% block title %}Add Task{% endblock %}

{% block content %}
  {% if user.is_anonymous == True %}
  <h1 class="text-center">You are not allowed to access this page</h1>
  {% else %}
    <div class="container">
      <div class="row">
        <div class="col-6 offset-3">
          <h1 class="text-center my-3">Add A Task</h1>
          {% if error == True %}
            <p class="text-danger">Duplicate task found</p>
          {% endif %}
          <form action="{% url 'todolist:add_task' %}" method="post">
            {% csrf_token %}

            <div class="mb-3">
                <label for="task_name">Task Name: </label>
                <input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
            </div>

            <div class="mb-3">
                <label for="description">Description: </label>
                <textarea class="form-control" name="description" value="{{ description }}" required></textarea>
            </div>

            <div class="text-center">
				    	<input class="btn btn-success" type="submit" value="Add Task">
					</div>


          </form>
        </div>
      </div>
    </div>
  {% endif %}
{% endblock %}

todolist/templates/todolist/change_password.html
{% extends 'base.html' %}

{% block title %}Change Password{% endblock %}

{% block content %}
    {% if is_password_changed %}
        <div class="container">
            <div class="row">
                <div class="col-6 offset-3 text-center">
                    <h1 class="my-3">User Password Successfully Updated!</h1>
                    <p>The password has been successfully updated</p>
                </div>
            </div>
        </div>
    {% else %}
        <div class="container">
            <div class="row">
                <div class="col-6 offset-3">
                    <div class="border p-4 text-center">
                        <h1>Password Change</h1>
                        <p>Username: {{ user.username }}</p>
                        <p>Email: {{ user.email }}</p>
                        <form method="post">
                            {% csrf_token %}
                            {{ form.as_p }}
                            <button type="submit" class="btn btn-primary">Change Password</button>
                        </form>
                        {% if form.errors %}
                            <p class="text-danger">There was an error with your submission. Please correct the errors below.</p>
                        {% endif %}
                    </div>
                </div>
            </div>
        </div>
    {% endif %}
{% endblock %}

todolist/templates/todolist/eventitem.html
{% extends 'base.html' %}

{% block title %}Event Item{% endblock %}

{% block content %}
<div class="text-center my-3">
	<h1>{{ event_name }}</h1>
	<h3>Description</h3>
	<p>{{ description }}</p>
	<h3>Status</h3>
	<p>{{ status }}</p>
	<h3>Event Date</h3>
	<p>{{ event_date }}</p>
	
	<button class="btn btn-primary mx-1 text-decoration-none">
		<a href="{% url 'todolist:update_event' id %}" class="text-light text-decoration-none">Edit Event</a>
	</button>

	<button class="btn btn-danger mx-1 text-decoration-none">
		<a href="{% url 'todolist:delete_event' id %}" class="text-light text-decoration-none">Delete Event</a>
	</button>

	<button class="btn btn-warning mx-1 text-decoration-none">
		<a href="{% url 'todolist:index' %}" class="text-light text-decoration-none">Back To Event</a>
	</button>
	
</div>

{% endblock %}

todolist/templates/todolist/index.html
{% extends 'base.html' %}

{% block title %} Home {% endblock %}

{% block content %}
    {% if todoitem_list and not user.is_anonymous %}
        <h1 class="text-center my-3"> Welcome {{user.first_name}} {{user.last_name}}!</h1>
        <div class="container">
            <div class="row">
                <h3 class="text-center mb-3">My Tasks</h3>
                <ul class="list-group col-lg-2 offset-lg-5 text-center">
                    {% for todoitem in todoitem_list %}
                        <a href="{% url 'todolist:viewtodoitem' todoitem.id %}" class="text-decoration-none">
                            <li class="list-group-item">{{ todoitem.task_name }}</li>
                        </a>
                    {% endfor %}            
                </ul>
            </div>
            <div class="row">
                <h3 class="text-center mb-3">My Events</h3>
                <ul class="list-group col-lg-2 offset-lg-5 text-center">
                    {% for eventitem in eventitem_list %}
                        <a href="{% url 'todolist:vieweventitem' eventitem.id %}" class="text-decoration-none">
                            <li class="list-group-item">{{ eventitem.event_name }}</li>
                        </a>
                    {% endfor %}            
                </ul>
            </div>
        </div>
    {% elif user.is_anonymous == True %}
        <h1 class="text-center my-3">You are not authorized to access this page</h1>
        <p class="text-center">Kindly login <a href="{% url 'todolist:login' %}">here</a></p>
    {% else %}
        <p>No tasks have been created</p>
    {% endif %}
{% endblock %}

todolist/templates/todolist/login.html
{% extends 'base.html' %}

{% block title %} Login {% endblock %}

{% block content %}
  <div class="container">
    <div class="row">
      <div class="col-6 offset-3">
        <h1 class="text-center my-3">Login</h1>
        {% if error == True %}
          <p class="text-danger">Invalid user credentials, please check your username and password</p>
        {% endif %}
        <form action="{% url 'todolist:login' %}" method="post">
          <!-- This template tag provides protection against Cross Site Request Forgeries (CSRF) -->
          <!-- CSRF occurs when a malicious website contains a link, a form button or some JavaScript that is intended to perform some action our website, using the credentials of a logged-in user -->
          {% csrf_token %}

          <div class="mb-3">
              <label for="username">Username: </label>
              <input class="form-control" id="username" type="text" name="username" value="{{ username }}" maxlength="20" required>
          </div>

          <div class="mb-3">
              <label for="password">Password: </label>
              <input class="form-control" id="password" type="password" name="password" value="{{ password }}" maxlength="20" required>
          </div>

          <div class="text-center">
              <input class="btn btn-success" type="submit" value="Login">
          </div>
        </form>
      </div>
    </div>
  </div>
{% endblock %}


<!-- {% if is_user_authenticated == False %}
  <h1> Something Went Wrong </h1>
  <p>Please contact your administrator or reset your password</p>
  <a href="{% url 'todolist:index' %}">Back to index page</a>
{% endif %} -->

todolist/templates/todolist/register.html
{% extends 'base.html' %}

{% block title %}Register{% endblock %}

{% block content %}
  <div class="container">
    <div class="row">
      <div class="col-6 offset-3">
        <h1 class="text-center my-3">REGISTER</h1>
        {% if registration_success %}
          <div class="modal fade" id="registrationSuccessModal" tabindex="-1" role="dialog" aria-labelledby="registrationSuccessModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title" id="registrationSuccessModalLabel">Registration Successful</h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  Your registration was successful. You can now log in.
                </div>
                <div class="modal-footer">
                  <button type="button" class="btn btn-secondary" data-dismiss="modal" onclick="redirectToLogin()">Close</button>
                </div>
              </div>
            </div>
          </div>
          <script>
            $(document).ready(function(){
              $('#registrationSuccessModal').modal('show');
            });
            function redirectToLogin() {
              window.location.href = "{% url 'todolist:login' %}";
            }
          </script>
        {% endif %}
        <form action="{% url 'todolist:register' %}" method="post">
          {% csrf_token %}
          {% if form.errors %}
          <div class="alert alert-danger">
            <ul>
              {% for field, errors in form.errors.items %}
                <li>{{ errors|join:", " }}</li>
              {% endfor %}
            </ul>
          </div>
          {% endif %}
          <div class="mb-3">
              <label for="username">Username: </label>
              <input class="form-control" id="username" type="text" name="username" maxlength="50" required>
          </div>

          <div class="mb-3">
              <label for="first_name">First Name: </label>
              <input type="text" id="first_name" class="form-control" name="first_name" required>
          </div>

          <div class="mb-3">
            <label for="last_name">Last Name: </label>
            <input type="text" id="last_name" class="form-control" name="last_name"  required>
          </div>

          <div class="mb-3">
            <label for="email">Email: </label>
            <input type="text" id="email" class="form-control" name="email"  required>
          </div>

          <div class="mb-3">
            <label for="password1">Password: </label>
            <input type="password" id="password1" class="form-control" name="password1"  required>
          </div>

          <div class="mb-3">
            <label for="password2">Confirm Password: </label>
            <input type="password" id="password2" class="form-control" name="password2" required>
          </div>
            <div class="text-center">
            <button type="submit" class="btn btn-success">Register</button>
          </div>
        </form>
      </div>
    </div>
  </div>
{% endblock %}

todolist/templates/todolist/todoitem.html
{% extends 'base.html' %}

{% block title %}To Do Item{% endblock %}

{% block content %}
<div class="text-center my-3">
	<h1>{{ task_name }}</h1>
	<h3>Description</h3>
	<p>{{ description }}</p>
	<h3>Status</h3>
	<p>{{ status }}</p>
	
	<button class="btn btn-primary mx-1 text-decoration-none">
		<a href="{% url 'todolist:update_task' id %}" class="text-light text-decoration-none">Edit Task</a>
	</button>

	<button class="btn btn-danger mx-1 text-decoration-none">
		<a href="{% url 'todolist:delete_task' id %}" class="text-light text-decoration-none">Delete Task</a>
	</button>

	<button class="btn btn-warning mx-1 text-decoration-none">
		<a href="{% url 'todolist:index' %}" class="text-light text-decoration-none">Back To Task</a>
	</button>
	
</div>

{% endblock %}

todolist/templates/todolist/update_event.html
{% extends 'base.html' %}

{% block title %}Update Event{% endblock %}

{% block content %}
  {% if user.is_anonymous == False %}
    <div class="container">
      <div class="row">
        <div class="col-6 offset-3">
          <h1 class="text-center my-3">Update Event</h1>
          {% if error == True %}
            <p class="text-danger">Event not found</p>
          {% endif %}
          <form action="{% url 'todolist:update_event' eventitem_id %}" method="post">
            {% csrf_token %}

            <div class="mb-3">
              <label for="event_name">Event Name: </label>
              <input class="form-control" id="event_name" type="text" name="event_name" value="{{ event_name }}" maxlength="50" required>
            </div>

            <div class="mb-3">
              <label for="description">Description: </label>
              <textarea class="form-control" name="description" required>{{ description }}</textarea>
            </div>

            <div class="mb-3">
              <label for="status">Status: </label>
              <input class="form-control" id="status" type="text" name="status" value="{{ status }}" maxlength="50" required>
            </div>

            <div class="mb-3">
              <label for="event_date">Event Date: </label>
              <input class="form-control" id="event_date" type="datetime-local" name="event_date" value="{{ event_date }}" required>
            </div>

            <div class="text-center">
              <input class="btn btn-success" type="submit" value="Update Event">
            </div>
          </form>
          {% if update_success %}
          <div class="modal fade" id="successModal" tabindex="-1" role="dialog" aria-labelledby="successModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title" id="successModalLabel">Update Successful</h5>
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                  <p>Event has been successfully updated.</p>
                </div>
                <div class="modal-footer">
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                  <a href="{% url 'todolist:index' %}" class="btn btn-primary">Go to Home</a>
                </div>
              </div>
            </div>
          </div>

          <script>
            $(document).ready(function(){
              $('#successModal').modal('show');
            });
          </script>
          {% endif %}
        </div>
      </div>
    </div>
  {% else %}
    <h1 class="text-center my-3">You are not authorized to access this page.</h1>
    <p class="text-center">Kindly login <a href="{% url 'todolist:login' %}">here</a></p>
  {% endif %}
{% endblock %}

todolist/templates/todolist/update_task.html
{% extends 'base.html' %}

{% block title %}Update Task{% endblock %}

{% block content %}
  {% if user.is_anonymous == False %}
  <div class="container">
    <div class="row">
      <div class="col-6 offset-3">
        <h1 class="text-center my-3">Update Task</h1>
        {% if error == True %}
          <p class="text-danger">Task not found</p>
        {% endif %}
        
        <form action="{% url 'todolist:update_task' todoitem_id %}" method="post">
          {% csrf_token %}

          <div class="mb-3">
              <label for="task_name">Task Name: </label>
              <input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
          </div>

          <div class="mb-3">
              <label for="description">Description: </label>
              <textarea class="form-control" name="description" required>{{ description }}</textarea>
          </div>

          <div class="mb-3">
              <label for="status">Status: </label>
              <input class="form-control" id="status" type="text" name="status" value="{{ status }}" maxlength="50" required>
          </div>

          <div class="text-center">
              <input class="btn btn-success" type="submit" value="Update Task">
          </div>

        </form>
      </div>
    </div>
  </div>
  {% else %}
    <h1 class="text-center my-3">You are not authorized to access this page.</h1>
    <p class="text-center">Kindly login <a href="{% url 'todolist:login' %}">here</a></p>
  {% endif %}
{% endblock %}